package com.xy.service;

import com.xy.entity.MercFeeCountMonth;
import com.xy.mapper.MercFeeCountMonthMapper;
import com.xy.service.MercFeeCountMonthService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;

import java.util.List;
import com.xy.utils.R;
import com.xy.utils.PageBean;
import com.xy.dto.MercFeeCountMonthDto;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.PostMapping;
import io.swagger.annotations.ApiOperation;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.xy.utils.MybatisPlusQuery;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.validation.annotation.Validated;
import com.xy.utils.Emptys;

import static com.xy.utils.Beans.copy;
import static com.xy.utils.PlusBeans.toIPage;
import static com.xy.utils.PlusBeans.toPageBean;


/**
* <p>
* 商户佣金费用收益每月统计（不含本月） 服务实现类
* </p>
*
* @author 谭斌
* @since 2024-04-23
*/
@Service
@AllArgsConstructor
@Api(tags = "商户佣金费用收益每月统计（不含本月）")
public class MercFeeCountMonthServiceImpl extends ServiceImpl<MercFeeCountMonthMapper, MercFeeCountMonth> implements MercFeeCountMonthService {

    @PostMapping("obj")
    @ApiOperation("对象查询")
    public R<MercFeeCountMonthDto.Vo> obj(@RequestBody MercFeeCountMonthDto.Vo vo) {
        MercFeeCountMonthDto.SelectList selectList = copy(MercFeeCountMonthDto.SelectList.class, vo);
        List<MercFeeCountMonthDto.Vo> list = list(selectList).getData();
        if(Emptys.check(list)) {
            return R.ok(list.get(0));
        }
        return R.ok();
    }

    @PostMapping("list")
    @ApiOperation("集合查询")
    public R<List<MercFeeCountMonthDto.Vo>> list(@RequestBody MercFeeCountMonthDto.SelectList selectList) {
        LambdaQueryWrapper<MercFeeCountMonth> lambdaQueryWrapper = new MybatisPlusQuery().eqWrapper(selectList, MercFeeCountMonth.class).build();
        List<MercFeeCountMonth> list = list(lambdaQueryWrapper);
        return R.ok(copy(MercFeeCountMonthDto.Vo.class, list));
    }

    @PostMapping("page")
    @ApiOperation("分页查询")
    public R<PageBean<MercFeeCountMonthDto.Vo>> page(@RequestBody MercFeeCountMonthDto.Page page) {
        PageBean pageBean = page.getPage();
        LambdaQueryWrapper<MercFeeCountMonth> lambdaQueryWrapper = new MybatisPlusQuery().eqWrapper(page, MercFeeCountMonth.class).build();
        IPage<MercFeeCountMonth> iPage = page(toIPage(pageBean), lambdaQueryWrapper);
        return R.ok(toPageBean(MercFeeCountMonthDto.Vo.class, iPage));
    }

    @PostMapping("save")
    @ApiOperation("添加")
    public R save(@RequestBody @Validated MercFeeCountMonthDto.Save save) {
        MercFeeCountMonth saveInfo = copy(MercFeeCountMonth.class, save);
        save(saveInfo);
        return R.ok();
    }

    @PostMapping("update")
    @ApiOperation("修改")
    public R update(@RequestBody @Validated MercFeeCountMonthDto.Update update) {
        MercFeeCountMonth updateInfo = copy(MercFeeCountMonth.class, update);
        updateById(updateInfo);
        return R.ok();
    }
}